import ex.accounts.BankAccount;
import ex.comms.Communicator;
import ex.exchange.CurrencyExchange;

public class Exchange {
    public static void main(String [] args)
	throws Exception
    {
	args = aos.jack.Kernel.init(args);

	CurrencyExchange cashier = new CurrencyExchange("edith");
	BankAccount accounts = new BankAccount("anne", cashier.name());

	Communicator communicator
	    = new Communicator("tony", cashier.name(), accounts.name());

	communicator.setRate("AUD", "USD", 0.50);
	communicator.setRate("YEN", "AUD", 0.0165);
	communicator.setRate("GBP", "YEN", 200.0);

	convert(communicator, "AUD", "USD", 100.0);
	convert(communicator, "AUD", "GBP", 15.0);
	convert(communicator, "AUD", "YEN", 20.0);
    }

    public static void convert(
	Communicator communicator, String c1, String c2, double amount)
	throws Exception
    {
	double converted = communicator.convert(c1, c2, amount);
	System.out.println(c1 + amount + " = " + c2 + converted);
    }
}
