<BAPI_Database =0
    <BAPI_Filename
	:version  36
	:superclass  "ClosedWorld"
	:doc
	    <BAPI_Text =1
		:hard_lab  "Doc:"
		:lab  "Documentation"
		:val  `   Relation RunwayInfo is used for keeping the current usage of a
   runway.
`
	    >
	:name  "RunwayInfo"
	:filename  "RunwayInfo.gdb"
	:type  "aos.jack.ed.Database"
	:java
	    <BAPI_Java =2
		:pkg
		    <BAPI_TextLine =3
		    >
		:imports
		    (
			<BAPI_TextLine =4
			    :val  "aos.jack.jak.util.timer.DilationController"
			>
		    )
		:code
		    (
			<BAPI_Text =5
			    :lab  "delfact"
			    :val  `    public void delfact(Tuple t, BeliefState was)
    {
        if (gui == null)
            return;
        RunwayInfo__Tuple info = (RunwayInfo__Tuple)t;
        gui.removeRow(info.ATL);
    }
`
			>
			<BAPI_Text =6
			    :lab  "newfact"
			    :val  `    public void newfact(Tuple t,BeliefState is,BeliefState was)
    {
        if (gui == null)
            return;
        RunwayInfo__Tuple info = (RunwayInfo__Tuple)t;
        gui.addRow(info.ATL,
                     info.aircraft+
                     " ["+DilationController.timeString(info.ETA)+"]");
    }
`
			>
			<BAPI_Text =7
			    :lab  "setName"
			    :val  `    void setName(String name,int index)
    {
        gui = new Stack(name,index);
    }
`
			>
			<BAPI_Text =8
			    :lab  "gui"
			    :val  `Stack gui;
`
			>
		    )
	    >
    >
    :dbfields
	(
	    <BAPI_DBField =9
		:name  "ATL"
		:isKey  :true
		:type  "long"
	    >
	    <BAPI_DBField =10
		:name  "aircraft"
	    >
	    <BAPI_DBField =11
		:name  "ETA"
		:type  "long"
	    >
	    <BAPI_DBField =12
		:name  "booking"
		:type  "boolean"
	    >
	)
    :queries
	(
	    <BAPI_DBQuery =13
		:name  "slotUsed"
		:logicals
		    (
			<BAPI_InternalRef =14
			    :ref
				<&10 >
			>
			<BAPI_InternalRef =15
			    :ref
				<&11 >
			>
			<BAPI_InternalRef =16
			    :ref
				<&12 >
			>
		    )
	    >
	    <BAPI_DBQuery =17
		:name  "usingSlot"
		:logicals
		    (
			<BAPI_InternalRef =18
			    :ref
				<&9 >
			>
			<BAPI_InternalRef =19
			    :ref
				<&11 >
			>
			<BAPI_InternalRef =20
			    :ref
				<&12 >
			>
		    )
	    >
	)
>
